unit dvip_sar;   //modulis

interface

type rod = ^el;                       // naudojamu naudotojo tipu sarasas
         el = record
         duom : integer;
         kitas : rod;
         taspats : rod;
    end;

procedure PrintList(elem: rod);                 //proceduru antrastes
procedure CountList(elem:rod);
procedure DeleteList(var pr:rod);
procedure IterptPradzion(var pr,elem:rod);
procedure IterptiGalan (var pab:rod);
procedure GautiDuomenis(pr:rod);
procedure GautiNumeri (pr:rod);
procedure IterptiYk (var pr:rod);
procedure PanaikintiElementa(var pr,pab:rod);

implementation                 // veiksmu dalis

{-----------------Saraso spausdinimo procedura---------------------------}

 procedure PrintList(elem: rod);      // pradzios, pabaigos ir darbine rodykle elem
                begin
                    if elem=nil then writeln('sarasas tuscias')   //patikrina ar sarasas tuscias
                    else
                    begin
                       writeln('Spausdinam sarasa: ');

                       while elem<>nil do     //begam per sarasa
                       begin
                          writeln(elem^.duom);   //spausdinam einamo elemento duomenis
                          elem:=elem^.kitas;
                       end;

                    end;
                end;
                
{--------------------Saraso elementu skaiciavimo procedura----------------}

procedure CountList(elem:rod);
                var  i:integer;
                begin
                    i:=0;
                    while elem<>nil do  //kol  einamas elementas nera nil
                        begin
                        i:=i+1;         // didinam skaitliuka
                        elem:=elem^.kitas;    // ir einam per sarasa
                        end;
                writeln('sarase esanciu elementu skaicius: ',i);  //isspausdinam
                end;

{----------------Saraso naikinimo procedura-------------------}

 procedure DeleteList(var pr:rod);
                var elem:rod;
                begin
		  elem:=pr;
                    while elem<>nil do
                        begin
                            elem:=pr^.kitas;  // papildomam elementui priskiriam antraji
                            dispose(pr);   // panaikinam pirmaji
                            pr:=elem;    // pirmaji priskiriam i antraji
                        end;
                    dispose(pr);
                writeln('sarasas sekmingai istrintas');
                end;

{----------------Iterpimo i pradzia procedura-------------------}

 procedure IterptPradzion(var pr,elem:rod);
          var  i:integer;
      begin    //iterpti elementa i saraso pradzia
        writeln('Iveskite duomeni kuri norite prideti i pradzia, noredami pabaigti spauskite 0');
        readln(i);
        while(i<>0) do
          begin
           new (elem);        //atminties isskyrimas
           elem^.duom:=i;
           elem^.kitas:=pr;
           pr^.taspats:=elem;
           pr:= elem;   //elementa prijungiam prie saraso
           writeln('Iveskite duomeni kuri norite prideti i pradzia, noredami pabaigti spauskite 0');
           readln(i);
          end;
      end;
      
{----------------Iterpimo i gala procedura-------------------}
 
 procedure IterptiGalan (var pab:rod);
       var elem:rod;
       begin
         new (elem);
         writeln('Koki duomeni norite ivesti i saraso gala:');
         readln(elem^.duom);       // nuskaitom duomenis i nauja elementa
         pab^.kitas := elem;       // pabaigos rodykle i sekanti elementa parodo i naujaji (saraso galo rodykle nukreipiama i nauja elementa)
         elem^.taspats := pab;     // naujo elemento rodykle i ankstesni nurodo i pries iterpima buvusi paskutini elementa
         elem^.kitas := nil;       // nustatom, kad pabaigoj butu nil
         pab := elem;              // pabaigos rodykle nustatom i naujaji elementa
       end;

 
{----------------K-tojo elemento duomenu gavimo procedura-------------------}

procedure GautiDuomenis(pr:rod);
        var nr,j:integer;
      begin    // isspausdina k-tojo elemento duomenis
        writeln('Iveskite numeri elemento, kurio duomenis norite gauti');
        readln(nr);
        j:=1;
        while (j <> nr) and (pr^.kitas<>nil) do
          begin
            pr:=pr^.kitas;    // nueina iki k-tojo elemento
            j:=j+1;
          end;
        if (j<nr) then writeln ('sarase nera tiek elementu')  // patikrina, ar nevirsija saraso ilgio
        else writeln ('elemento nr ',nr,' duomenys: ',pr^.duom);  // isspausdinam k-tojo suomenis
     end;
 
{----------------Elemento duomenu pagal numeri radimo procedura-------------------}

procedure GautiNumeri (pr:rod);
      var d,j:integer;
     begin  // suranda pirmojo elemento numeri su nurodytais duomenimis
       writeln('Iveskite duomenis, kurio numerio ieskosite');
       readln(d);   // nuskaitom duomenis, kuriu ieskosim sarase
       j:=1;
       while (d <> pr^.duom) and (pr^.kitas<>nil) do       // einam per sarasa kol nesutampa duomenys arba kol neprieinam saraso galo
         begin
           pr:=pr^.kitas;
           j:=j+1;          // didinam skaitliuka
         end;
       if (pr^.duom <> d) then writeln ('sarase nera elemento su tokiais duomenimis') // jei neradom tokio elemento
       else writeln ('pirmo elemento su duomenimis: ',d,' numeris: ',j); // isspausdinam numeri
     end;

 
{----------------Duomenu iterpimo i k-taja vieta procedura-------------------}

procedure IterptiYk (var pr:rod);
       var elem:rod;
           elem_k : rod;
           i,k: integer;
     begin
         new (elem);
         elem_k:=pr;
         writeln('Iveskite duomeni kuri norite prideti i k vieta');
         readln(elem^.duom);
         writeln('Iveskite i kuria vieta norite iterpti');
         readln(k);
         i:=1;
         k:=k-1; // atimam viena tam, kad iterptu i nurodyta k-taji elementa
                 // nes jis eina iki k vietos ir iterpia nauja elementa po k
         if (k=0) then
         begin       // cia iterps elementa i saraso pirma elementa
           elem^.kitas:=elem_k;    // naujo elemento sekanti rodykle priskiriama pirmajam saraso elementui
           elem_k^.taspats:=elem;  // pirmojo elemento atgaline rodykle priskiriama naujam elementui
           pr:=elem;    // saraso pradzia paslenkama i nauja elementa
         end
         else
         begin            //Iterpia elementus i k-taja vieta
           while ( i < k ) and ( elem_k^.kitas <> nil ) do
              begin
                  elem_k := elem_k^.kitas;  // "nukeliajam" iki k-tojo elemento
                  i:=i+1;
              end;
          if (i=k) and (elem_k^.kitas<>nil) then
          begin
            elem^.kitas := elem_k^.kitas; // naujo elemento rodykle i sekanti rodo i k+1 elementa
            elem^.taspats := elem_k;      // naujo elemento redykle i ankstesni rodo i k elementa
            elem_k^.kitas := elem;        // k-tojo elemento rodykle  sekanti nurodo i naujaji elelementa
            elem_k:=elem_k^.kitas^.kitas; // paeinam per pora elementu i prieki  elem_k pasidare sekantis po naujo elem
            elem_k^.taspats := elem;      // k+1 elemento rodykle i ankstesni nurodo i naujaji
          end
          else writeln('jusu ivestas k per didelis sarasui');
         end;
     end;

 
{----------------Elemento naikinimo procedura-------------------}

procedure PanaikintiElementa(var pr,pab:rod);
       var i,k:integer;
           elem,elem2:rod;
     begin    // panaikina k-taji elementa is saraso
        writeln ('kuri elementa norite panaikinti?');
        readln(i);
        elem:=pr;
        if (i=1) then   // jei ivedem viena, tai panaikins pirma (tai paprasciau atliekama)
        begin
          pr:=pr^.kitas;    //rodykle i pirma elementa pastumiam per viena vieta
          dispose(elem);   // atlaisvinam pirmo elemento vieta
        end
        else   // jei ivestas didesnis uz 1 numeris
        begin
          k:=1;
          while (i <> k) and (elem^.kitas<>nil) do       // kol i nelygu k ir kol ne saraso pabaiga
          begin
            elem:=elem^.kitas;       // begam per sarasa iki k-tojo elemento
            k:=k+1;
          end;
          if (elem^.kitas<>nil) then   // jei tai nera paskutinis elementas (trynimas saraso viduryje)
          begin
            elem2:=elem^.kitas;         // papildomam elementui priskiram k+1
            elem2^.taspats := elem^.taspats;  // papildomo elemento atgaline rodykle nustatoma i k-1
            dispose(elem);                // panaikinam k elementa
            elem2^.taspats^.kitas:=elem2; // naujo elemento rodykle i sekanti nustatoma i k+2
          end
          else   // jei tai yra paskutinis elementas
          begin
            elem:=pab;
            pab:=pab^.taspats;    // pabaigos rodykle pastumiam per viena elementa atgal
            pab^.kitas:=nil;    // pabaigos rodykle i sekanti nustatom i nil
            dispose(elem);     // atlaisvinam vieta
          end;
        end;
        writeln('elementas sekmingai istrintas');
     end;
     
end.
